/*
 * Copyright  2007-2009 The MorphOS Development Team
 *
 * $Id: StrnCmp.c,v 1.4 2010/02/27 18:47:46 itix Exp $
 */

#include "../english.c"
#include "../strcompareinternal.c"

ULONG LIB_null(void) { return 0; }

#if 1
STATIC CONST_STRPTR tab[] =
{
	"00",
	"01",
	"00",
	"10",
	"00",
	"10",
	"1000",
	"800x600",
	"1024x768",
	"abasdgsdf",
	"8x8",
	"00000000134590859",
	"",
	"x",
	"0",
	"1024x024",
	"1024x700",
	"1024x1000",
	"2024x024",
	"2024x700",
	"2024x1000",
	"12",
	NULL
};
#else
STATIC CONST_STRPTR tab[] =
{
	"cc1",
	"cc1plus",
	"cc01",
	"cc01plus",
	"cc1",
	"cc1plus",
	"cc1",
	"cc1plus",
	"cc1",
	"cc1plus",
	"cc01",
	"cc01plus",
	"cc01",
	"cc01plus",
	NULL
};
#endif

static void sort_it(LONG length, LONG count)
{
	CONST_STRPTR *ptr = tab;
	ULONG keep_going;

	ptr = tab;

	do
	{
		ULONG idx = 0;
		keep_going = 0;

		for (idx = 0; idx < count-1; idx++)
		{
			LONG rc;

			//printf("compare %s vs %s\n", tab[idx], tab[idx+1]);

			REG_A1 = (IPTR)tab[idx];
			REG_A2 = (IPTR)tab[idx+1];
			REG_D0 = length;
			REG_D1 = SC_ASCII;

			rc = LIB_strcompare();

			if (rc > 0)
			{
				APTR tmp = (APTR)tab[idx];
				keep_going = 1;
				tab[idx] = tab[idx+1];
				tab[idx+1] = tmp;
			}
		}
	}
	while (keep_going);

	printf("\nSorted order (length == %d):\n", length);

	do
	{
		printf("%s\n", *ptr);
		ptr++;
	}
	while (*ptr);
}

struct StrComp
{
	CONST_STRPTR s1, s2;
	LONG length;
};

static struct StrComp strcomp[] =
{
	{ "40,", "50", 1 },
	{ "40,", "50", 2 },
	{ "40,", "50", 3 },
	NULL
};

static void comparetest(void)
{
	ULONG i = 0;

	printf("\nCompare some strings:\n");
	do
	{
		LONG rc;

		REG_A1 = (IPTR)strcomp[i].s1;
		REG_A2 = (IPTR)strcomp[i].s2;
		REG_D0 = strcomp[i].length;
		REG_D1 = SC_ASCII;

		rc = LIB_strcompare();

		printf("\"%s\" vs \"%s\", length %d, %s\n", strcomp[i].s1, strcomp[i].s2, strcomp[i].length, rc == 0 ? "FAILED" : "OK");

		i++;
	}
	while (strcomp[i].s1);
}

int main(int argc, char *argv[])
{
	CONST_STRPTR *ptr = tab;
	ULONG count = 0;
	ULONG length = 0;

	printf("Unsorted order:\n");

	do
	{
		printf("%s\n", *ptr);
		ptr++;
		count++;
	}
	while (*ptr);

	if (argc >= 2)
	{
		length = argv[1][0] - '0';
	}

	sort_it(-1, count);

	if (length != 0)
		sort_it(length, count);

	comparetest();

	return 0;
}
